//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.io;

import java.io.OutputStream;
import java.io.Writer;


public class JavaPrintWriter extends PrintWriter {
    
    public JavaPrintWriter(OutputStream stream) {
	super(stream);
    }
    public JavaPrintWriter(OutputStream stream, boolean autoFlush) {
	super(stream, autoFlush);
    }
    
    public JavaPrintWriter(Writer writer) {
	super(writer);
    }
    public JavaPrintWriter(Writer writer, boolean autoFlush) {
	super(writer, autoFlush);
    }
    
	
    protected void indent() {
	for (int i = 0; i < indent; ++i) print(indentString);
    }
	    
    public void printField(Value value) {
	if (value.object == null) printNullObject();
	else {
	    printType(value, false, false);
	
	    separateTypeAndName();
	    printName(value.name);
	    separateNameAndValue();
	    printValue(value);
	    print(";");
	    separateObjectItems();
	}
    }
    
    protected void newlineAndIndent() {
	print("\n");
	indent();
    }
    
    public void beginList() {
	print("{");
	++indent;
	if (prettyOutput()) newlineAndIndent();
    }
    
    public void endList() {
	if (--indent < 0) indent = 0;
	if (prettyOutput()) newlineAndIndent();
	print("}");
    }

    public void beginObject() {
	beginList();
    }

    public void endObject() {
	endList();
    }

    protected void separateObjectItems() {
	if (prettyOutput()) newlineAndIndent();
	else print(" ");
    }

    protected void separateTypeAndName() { print(" "); }
    
    protected void separateNameAndValue() {
	if (prettyOutput()) print(" = ");
	else print("=");
    }
    
    protected void printNullString() {
	print("null;");
    }
    protected void printNullObject() {
	print("null;");
    }

    private int indent = 0;
    private static final String indentString = "    ";
}
