//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.io;

/**
 * This encapsulates the context and value of a call to one of the
 * print functions.  It makes it so the interfaces of derived
 * classes will not have to change if more contextual information
 * is added to a value.
 **/
public class Value {
    public String name;
    public Object object;
    public Class clazz;
    public boolean isFirst = false;
    public boolean isLast = false;
    public boolean isSubObject = false;

    public Value(String name, Object object, boolean isSubObject) {
	this.name = name;
	this.object = object;
	this.clazz = (object == null) ? Object.class : object.getClass();
	this.isSubObject = isSubObject;
    }

    public String getName() { return name; }
    public void setName(String name) { this.name = name; }
    
    public Object getObject() { return object; }
    public void setObject(Object object) { this.object = object; }
    
    public Class getObjectClass() { return clazz; }
    public void setObjectClass(Class clazz) { this.clazz = clazz; }
    
    public boolean isFirst() { return isFirst; }
    public void setIsFirst(boolean isFirst) { this.isFirst = isFirst; }
    
    public boolean isLast() { return isLast; }
    public void setIsLast(boolean isLast) { this.isLast = isLast; }
    
    public boolean isSubObject() { return isSubObject; }
    public void setIsSubObject(boolean isSubObject) {
	this.isSubObject = isSubObject;
    }

    public boolean isPrimitive() {
	return isPrimitive(true);
    }
    
    public boolean isPrimitive(boolean includeWrappers) {
	return clazz.isPrimitive()
	    || clazz == String.class
	    || (includeWrappers && (
		clazz == Integer.class
		|| clazz == Long.class
		|| clazz == Byte.class
		|| clazz == Boolean.class
		|| clazz == Float.class
		|| clazz == Double.class
		|| clazz == Character.class));
    }

    public void printTo(PrintWriter writer) {
	writer.printField(this);
    }

    public String toString() { return object.toString(); }
}
