//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.io.test;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.TimeZone;
import java.text.SimpleDateFormat;

import grace.io.FormattedPrintWriter;
import grace.io.PrintWriter;

public class FormattedPrintWriterTest {
    private int i = 1;
    private float f = 1.0f;
    private String s = "s";
    public Date d; {
	GregorianCalendar calendar = new GregorianCalendar();
	calendar.setTimeZone(TimeZone.getTimeZone("MST"));
	calendar.set(1963, 1, 12, 20, 30, 1);
	d = new Date(calendar.getTime().getTime());
    }
    private Vector v = new Vector(); {
	v.addElement("element 1");
	v.addElement("element 2");
	v.addElement("element 3");
    }
    private String[] a = { "1", "2", "3" };
    public Hashtable h = new Hashtable(); {
	h.put("a", "1");
	h.put("b", "2");
	h.put("c", "3");
    }

    public int getI() { return i; }
    public float getF() { return f; }
    public String getS() { return s; }
    public Vector getV() { return v; }
    public String[] getA() { return a; }

    public void setTimeStuff(PrintWriter writer, String format, String zone)
    {
	SimpleDateFormat dateFormat =
	    new SimpleDateFormat(format);
	dateFormat.setTimeZone(TimeZone.getTimeZone(zone));
	writer.setDateFormat(dateFormat);
    }

    
    public void run() {
	FormattedPrintWriter writer;

	//
	// Multiline java, full classnames.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.setFormat("", "{\n", "%i%C %n = %v;\n", "%i}");
	setTimeStuff(writer, "MMM.dd.yyyy.hh.mm.ss", "MET");
	writer.print("this", this);
	writer.println();

	//
	// Compact single line java format.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.setFormat("", "{", "%c %n=%v;", "}");
	setTimeStuff(writer, "dd MMM yyyy hhmmss", "MST");
	writer.print("this", this);
	writer.println();

	//
	// int with previous format.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.print("i", 1);
	writer.println();

	//
	// String with previous format.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.print("s", "a string");
	writer.println();

	//
	// Prettier single line java format.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.setFormat("", "{ ", "%c %n = %v; ", " }");
	// use default timezone and format
	writer.print("this", this);
	writer.println("\n");

	//
	// Single line lisp format.
	//
	writer = new FormattedPrintWriter(System.out, true);
	writer.setFormat("", "(", "%v%z,%z ", ")");
	writer.print("this", this);
	writer.println("\n");
    }

    public static void main(String[] args) {
	new FormattedPrintWriterTest().run();
    }
}
