//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.log;

import java.rmi.RemoteException;


public interface Distributer extends java.rmi.Remote {
    public static final String rcsid = "$Id: Distributer.java,v 1.3 1999/10/11 00:09:59 cbladon Exp $";

    /**
     * The name of this Distributer uniquely identifies it among all
     * Distributers on the internet.  It defaults to the VMID plus a
     * sequence number unless the name is overridden by the set name
     * function.
     **/
    public String getName() throws RemoteException;
    public void setName(String name) throws RemoteException;
    
    public void distribute(Event event) throws RemoteException;

    public void addHandler(Handler handler) throws RemoteException;
    public void addHandler(Handler handler, String event)
	throws RemoteException;


    /**
     * Enables or disables the logging of the given event type.  Can
     * be called at any point during the execution of the program.
     **/
    public void enableEventType(String eventType, boolean enabled)
	throws RemoteException;
    /**
     * Indicates that the given eventType is will be distributed to
     * the Handlers.
     **/
    public boolean eventTypeEnabled(String eventType) throws RemoteException;
}
