//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.log;

import java.net.URL;
import java.rmi.RemoteException;


/**
 * This forwards all log entries to the host and distributer given in
 * the url property.  This is useful for forwarding all log messages
 * to a central log facility.
 *
 * <p>Properties:
 * <ul>
 * <li>log.handler.<name>.url="rmi://<i>host</i>/log.distributer.<i>name</i>"
 * </ul>
 **/
public class ProxyHandler implements Handler {
    public static final String rcsid = "$Id: ProxyHandler.java,v 1.5 1999/10/11 00:10:01 cbladon Exp $";

    Distributer distributer;
    
    /**
     * This constructs initialized by properties.
     **/
    public ProxyHandler(Distributer distributer) throws RemoteException
    {
	this.distributer = distributer;
    }

    
    /**
     * The handle(Event) call is caught here and sent to the remote
     * distributer.
     **/
    public synchronized void handle(Event event) throws RemoteException {
	distributer.distribute(event);
    }
}


