//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.log;

import grace.util.Properties;

/**
 * This class simply redirects the PrintHandler to print to the
 * standard output.  The FileHandler sort of does this too if one
 * doesn't set up any writers to which it should write.  However, this
 * class is symantically clearer and separates it out for possibly
 * future functionality.
 *
 * <P>properties:
 * <ul>
 * <li>log.handler.<i>name</i>.stream = out|err
 * </ul>
 **/
public class StandardOutHandler extends PrintHandler implements Handler {
    public static final String rcsid = "$Id: StandardOutHandler.java,v 1.20 1999/10/11 00:10:01 cbladon Exp $";

    /**
     * This constructs a FileHandler that does not read any properties
     * and begins printing to the standard
     * output.
     **/
    public StandardOutHandler()
	throws java.rmi.RemoteException
    {
	super(System.out);
    }
    
    /**
     * This constructs a FileHandler that reads properties based on
     * the given name and begins printing to the standard output.
     **/
    public StandardOutHandler(String prefix, String name)
	throws java.rmi.RemoteException
    {
	super(prefix, name);

	Properties properties = new Properties();
	properties.loadSystem();
	
	if (properties.get(prefix + name + ".stream", "out").equals("out")) {
	    setOut(System.out);
	}
	else setOut(System.err);
	
	Log.internal("");
    }
}
