//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.log.test.centralized;

import java.util.*;

import grace.log.*;
import grace.util.Registry;

/**
 * This program looks on the given the host (via command line) for any
 * grace.log.Distributers registered in the rmiregistry and installs
 * proxy handlers.  Then it starts generating log messages in order to
 * test if each of the distributers are receiving the log messages
 * generated by this class.  If a host is not specified on the command
 * line, the localhost rmiregistry is consulted.
 *
 * <p>To run the full test:
 * <ul>
 * <li>java grace.log.test.centralized.Server
 * <li>java grace.log.test.centralized.Receiver [server-hostname]
 * <li>java grace.log.test.centralized.Sender [server-hostname]
 * </ul>
 **/
public class Receiver implements grace.log.Handler {
    String host = "localhost";
    
    public static void main(String[] args) {
	Receiver receiver = new Receiver();
	if (args.length > 0) receiver.host = args[0];
	receiver.run();
    }


    public Receiver() {
	try { java.rmi.server.UnicastRemoteObject.exportObject(this); }
	catch (java.rmi.RemoteException e) { Log.internal(e); }
    }

    public void run() {
	try {
	    String[] distributers = Registry.lookup(
		"rmi://" + host + "/log\\.distributer.*");

	    for (int i = 0; i < distributers.length; ++i) {
		try {
		    Distributer distributer =
			(Distributer) java.rmi.Naming.lookup(distributers[i]);
		    distributer.addHandler(this);
		}
		catch (Exception e) {
		    Log.internal(distributers[i] + " broken; ignored");
		    Log.internal(e);
		}
	    }
	}
	catch (Exception e) {
	    Log.error(e);
	}
    }

    public void handle(grace.log.Event event) {
	Log.getInstance().distribute(event);
    }
}
