//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.log.test.handlers.jdbc;

import grace.log.Log;

/**
 * This tests the JDBCHandler.  It tests the default configuration and
 * a completely custom configuration.
 **/
public class Test extends grace.test.Base {
    int sampleInt = 1;
    String sampleString = "a string";
    
    public void run() {
	report("Test " + Test.class.getName());

	properties.put("jdbc.drivers", "postgresql.Driver");

	//
	// Set up to log to the default lgging system.
	//
	properties.put(
	    "log.handler.jdbc-default.url",
	    "jdbc:postgresql:grace");
	properties.put(
	    "log.handler.jdbc-default.username",
	    properties.get("user.name"));
	properties.put("log.handler.jdbc-default.password", "");

	//
	// Set up to log to the custom database.
	//
	properties.put(
	    "log.handler.jdbc-custom.url",
	    "jdbc:postgresql:grace");
	properties.put(
	    "log.handler.jdbc-custom.username",
	    properties.get("user.name"));
	properties.put("log.handler.jdbc-custom.password", "");
	properties.put("log.handler.jdbc-custom.table", "CustomLog");
	properties.put(
	    "log.handler.jdbc-custom.format",
	    "'%e', '%(%j)o', '%m', '%l', '%f', '%c', '%h', '%n', '%t'");
	properties.put(
	    "log.handler.jdbc-custom.columns",
	    "type, object, message, line, function, class, thread, "
	    + "number, eventtime");

	//
	// Set up a standard out handler just to make sure things are
	// working.
	//
	properties.put("log.handler.stdout.url", "file:-");
	
	Log.notice("test message");
	Log.notice("testObject", this);
    }

    public int getSampleInt() { return sampleInt; }
    public String getSampleString() { return sampleString; }

    public static void main(String[] args) {
	new Test().run();
    }
}

