//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
//
// Copyright (C) 1999 Grace Software
//
// The contents of this file are subject to the Grace Software Public
// License Version 1.0 (the "GracePL"); you may not use this file
// except in compliance with the GracePL. You may obtain a copy of the
// GracePL at http://www.homestead.com/javalog/files/license.html
//
// Software distributed under the GracePL is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
// the GracePL for the specific language governing rights and
// limitations under the GracePL.
//
// The Original Code is Grace Software's JavaLog code, released March
// 21, 1999.
//
// The Initial Developer of the Original Code is Grace Software.
// Portions created by Grace Software are Copyright (C) 1999 Grace
// Software. All Rights Reserved.
//
// Contributor(s):
//
package grace.util;

import java.util.Date;
import java.util.TimeZone;
import java.util.GregorianCalendar;
import java.util.Calendar;

import grace.log.Log;


/**
 * Currently, this class only implements static utility functions that
 * the lame java.util.Date and Calendar classes do not implement.
 **/
public class Time {
    private static final TimeZone gmt = TimeZone.getTimeZone("GMT");

    //
    // The following two calendars are for the mergedDateAndTime()
    // function.
    //
    private static Calendar timeCalendar = new GregorianCalendar(gmt);
    private static Calendar dateCalendar = new GregorianCalendar(gmt);
	

    /**
     * Convenience function for returning the GMT time zone.
     **/ 
    public static final TimeZone gmt() { return gmt; }
    
    /**
     * This returns the merge of the given date and time such that the
     * returned result has the given date <i>but</i> the given time.
     *
     * @param date to use for returned result
     * @param time to use for returned result
     *
     * @return date part of date merged with time part of time
     **/
    public static Date mergedDateAndTime(Date date, Date time) {
	timeCalendar.setTime(time);
	dateCalendar.setTime(date);

	//
	// Now merge the two times.  A braindamaged bug in the
	// calendar is that it clears out all of the fields, contrary
	// to the documentation.  So, all of the fields are given here
	// just to be sure they are all set.
	//
	timeCalendar.set(
	    dateCalendar.get(Calendar.YEAR),
	    dateCalendar.get(Calendar.MONTH),
	    dateCalendar.get(Calendar.DATE),
	    timeCalendar.get(Calendar.HOUR_OF_DAY),
	    timeCalendar.get(Calendar.MINUTE),
	    timeCalendar.get(Calendar.SECOND));

	return timeCalendar.getTime();
    }


    //
    // The following is simply a design.  All of the functions must
    // assume GMT time zone.
    //
    public Time() {}
    public Time(Date date) {}
    public void parse(String format, String date) {}
    public void merge(String format, String date) {}
    public String format(String format) { return null; }

    public boolean isHoliday() { return false; }	// where?
    public boolean isWeekend() { return false; }	// where?
    public boolean isWeekday() { return false; }	// where?
}
